<?php





	/******************************************\
	* Web Application 6.0 by SCFDuffy (C) 2022 *
	* ---------------------------------------- ********************\
	* SCFDuffy retains the absolute copyright on this source code. *
	* This includes portions written in PHP, SQL, CSS, Javascript, *
	* HTML and any prosaic writings contained in this file. It may *
	* not be copied, clipped, modified or published in whole or in *
	* part without the expressed prior consent of SCFDuffy. These  *
	* rights of copy are retained to the fullest extent applicable *
	* in law. All Rights Reserved. (C) Copyright SCFDuffy 2021 (C) *
	* ------------------------------------------------------------ *
	* Web Application 6.0 written by SCFDuffy        (C) July 2022 *
	\**************************************************************/






	$homepath=dirname($_SERVER['SCRIPT_NAME']);
	$homepath=($homepath=='/')?$_SERVER['DOCUMENT_ROOT']:$_SERVER['DOCUMENT_ROOT'].$homepath;
	while (!file_exists($homepath.'/main')) $homepath=dirname(substr($homepath,0,-1));
	require_once($homepath.'/main/classes/Application.php');

	$app->renderHead("SocialShare Plugin - {$app->settings['sitename']}",'SCFDuffy',"SocialShare Plugin, Social Share, Social, Share, Plugin","Configuration for the SocialShare Plugin for Auranos.org Application v6.0");
	$app->renderHeader();

	if ($app->userPrivs($app->user['account_type'],'technical')<0){
?>
<article>
	<h1>Special Page</h1>
	<section class='center'>
		<h3>Website Settings</h3>
		<details class='help' ontoggle='app.resize();'>
			<summary>Help</summary>
			<div class='helpbox'>
				<h3>Accessing Website Settings</h3>
				<p>If you believe you should have the priveleges to access this part
				of the website but are unable to access this page properly then you
				should make sure that you are logged in under the correct account
				and if you still cannot access the settings, speak to either an
				administator or the director (or webmaster) to have them raise your
				privelege level to access this part of the website.
				</p>
			</div>
		</details>
			<div style='padding:0 1rem;text-align:left;'>
				<p>You must be logged in using an account with sufficient priveleges
				to alter the settings of the website.
				</p>
				<p>As a general rule, only users with technical priveleges can alter
				the settings of the website itself. This includes the website director
				(ie The Webmaster), administration staff and anyone who has been given
				technical priveleges to alter the website such that they may need to
				access these settings.
				</p>
				<p>Moderators, writers, affiliates and members with higher priveleges
				than ordinary members are, as a general rule, not permitted to alter
				the settings of the website itself, albeit that they may have an
				enhanced privelege level on other parts of the website.
				</p>
		</div>
	</section>
</article>
<?php
	}
	else{
		$socialshareconfig=false;
		if (file_exists("{$app->homepath}/main/plugins/socialshare/config.json"))
			$socialshareconfig=file_get_contents("{$app->homepath}/main/plugins/socialshare/config.json");
		if ($socialshareconfig!==false) $socialshareconfig=json_decode($socialshareconfig,true);
		else{
			$socialshareconfig['Facebook']='0';
			$socialshareconfig['Twitter']='0';
			$socialshareconfig['Clipboard']='0';
			$socialshareconfig['LinkedIn']='0';
		}
		foreach ($socialshareconfig as $sss=>$val){
			if (isset($_POST[$sss])) $socialshareconfig[$sss]=$_POST[$sss];
		}
		file_put_contents("{$app->homepath}/main/plugins/socialshare/config.json",json_encode($socialshareconfig));
?>
<article>
	<h1>SocialShare Plugin</h1>
	<section class='center'>
		<h1>This is the configuration page for the SocialShare Plugin</h1>
		<p class='center'>Select which services you wish members to share to.
		</p>
		<div class='aligner'>
			<form method='post'>
				<?php
					foreach ($socialshareconfig as $sss=>$var){
						echo "<h3>$sss<input name='$sss' type='range' class='boolean' min='0' max='1' value='$var' /></h3>";
					}
				?>
				<br/>
				<input type='submit' value='Use These Settings' />
			</form>
		</div>
		<br/><br/>
		<?php echo "<a href='{$app->homedir}/main/special/setup.php?anchor=Plugins'><img class='icon' src='{$app->homedir}/main/style/icons/back.png' /><br />back</a>"; ?>
	</section>
</article>
<?php
	}
	$app->renderFooter();
	$app->renderTail();
?>
